
# Pd Manual

This is the Manual for Pd, a patchable environment for audio analysis,
synthesis, and processing, with a rich set of multimedia capabilities.
The latest version of this page can be found at:
<http://msp.ucsd.edu/software.html>.

1.  [introduction]({{< mdlink "introduction" >}})
    1.  [guide to the documentation]({{< mdlink "introduction" "guide to the documentation" >}})
    1.  [other resources]({{< mdlink "introduction" "other resources">}})
1.  [theory of operation]({{< mdlink "theory of operation" "">}})
    1.  [overview]({{< mdlink "theory of operation" "overview">}})
        1.  [main window, canvases, and printout]({{< mdlink "theory of operation" "main window, canvases, and printout">}})
        1.  [object boxes]({{< mdlink "theory of operation" "object boxes">}})
        1.  [message and GUI boxes]({{< mdlink "theory of operation" "message and GUI boxes">}})
        1.  [patches and files]({{< mdlink "theory of operation" "patches and files">}})
    1.  [how to edit patches]({{< mdlink "theory of operation" "editing Pd patches">}})
        1.  [edit and run mode]({{< mdlink "theory of operation" "edit and run mode">}})
        1.  [creating boxes]({{< mdlink "theory of operation" "creating boxes">}})
        1.  [the selection]({{< mdlink "theory of operation" "the selection">}})
        1.  [deleting, cutting, and pasting]({{< mdlink "theory of operation" "deleting, cutting, and pasting">}})
        1.  [changing the text]({{< mdlink "theory of operation" "changing the text">}})
        1.  [connecting and disconnecting boxes]({{< mdlink "theory of operation" "connecting and disconnecting boxes">}})
        1.  [properties and help]({{< mdlink "theory of operation" "popup menu for properties, open, and help">}})
    1.  [messages]({{< mdlink "theory of operation" "messages">}})
        1.  [anatomy of a message]({{< mdlink "theory of operation" "anatomy of a message">}})
        1.  [depth first message passing]({{< mdlink "theory of operation" "depth first message passing">}})
        1.  [hot and cold inlets and right to left outlet
            order]({{< mdlink "theory of operation" "hot and cold inlets and right to left outlet order">}})
        1.  [message boxes]({{< mdlink "theory of operation" "message boxes">}})
    1.  [audio signals]({{< mdlink "theory of operation" "audio signals">}})
        1.  [sample rate and format]({{< mdlink "theory of operation" "sample rate and format">}})
        1.  [tilde objects and audio connections]({{< mdlink "theory of operation" "tilde objects and audio connections">}})
        1.  [converting to and from messages]({{< mdlink "theory of operation" "converting audio to and from messages">}})
        1.  [switching and blocking]({{< mdlink "theory of operation" "switching and blocking">}})
        1.  [nonlocal signal connections]({{< mdlink "theory of operation" "nonlocal signal connections">}})
    1.  [scheduling]({{< mdlink "theory of operation" "scheduling">}})
        1.  [audio and messages]({{< mdlink "theory of operation" "audio and messages">}})
        1.  [computation load]({{< mdlink "theory of operation" "computation load">}})
        1.  [determinism]({{< mdlink "theory of operation" "determinism">}})
    1.  [semantics]({{< mdlink "theory of operation" "semantics">}})
        1.  [creation of objects]({{< mdlink "theory of operation" "creation of objects">}})
        1.  [persistence of data]({{< mdlink "theory of operation" "persistence of data">}})
        1.  [message passing]({{< mdlink "theory of operation" "message passing">}})
        1.  [inlets and lists]({{< mdlink "theory of operation" "inlets and lists">}})
        1.  [dollar signs]({{< mdlink "theory of operation" "dollar signs">}})
    1.  [subpatches]({{< mdlink "theory of operation" "subpatches">}})
        1.  [abstractions]({{< mdlink "theory of operation" "abstractions">}})
        1.  [graph-on-parent subpatches]({{< mdlink "theory of operation" "graph-on-parent subpatches">}})
    1.  [numeric arrays]({{< mdlink "theory of operation" "numeric arrays">}})
    1.  [data structures]({{< mdlink "theory of operation" "data structures">}})
        1.  [traversal]({{< mdlink "theory of operation" "traversal">}})
        1.  [accessing and changing data]({{< mdlink "theory of operation" "accessing and changing data">}})
        1.  [editing]({{< mdlink "theory of operation" "editing">}})
        1.  [limitations]({{< mdlink "theory of operation" "limitations">}})
1.  [getting Pd to run]({{< mdlink "getting Pd to run" "">}})
    1.  [audio and MIDI]({{< mdlink "getting Pd to run" "audio and MIDI">}})
    1.  [installing Pd in Microsoft Windows]({{< mdlink "getting Pd to run" "installing Pd in Microsoft Windows">}})
    1.  [installing Pd in Linux]({{< mdlink "getting Pd to run" "installing Pd in Linux">}})
    1.  [installing Pd in macOS]({{< mdlink "getting Pd to run" "installing Pd in macOS">}})
    1.  [preferences and startup options]({{< mdlink "getting Pd to run" "preferences and startup options">}})
    1.  [how Pd searches for files]({{< mdlink "getting Pd to run" "how Pd searches for files">}})
1.  [externals]({{< mdlink "externals" "">}})
    1.  [external objects & libraries]({{< mdlink "externals" "external objects & libraries">}})
        1.  [what are: vanilla objects, internals &
            externals?]({{< mdlink "externals" "what-are-vanilla-objects-internals--externals">}})
        1.  [what are the types of external objects?]({{< mdlink "externals" "what are the types of external objects?">}})
            1.  [compiled objects:]({{< mdlink "externals" "compiled objects:">}})
            1.  [abstractions:]({{< mdlink "externals" "abstractions:">}})
        1.  [what are external libraries?]({{< mdlink "externals" "what are external libraries?">}})
        1.  [what are the types of external libraries?]({{< mdlink "externals" "what are the types of external libraries?">}})
    1.  [installing external objects and libraries]({{< mdlink "externals" "installing external objects and libraries">}})
        1.  [where to include the externals?]({{< mdlink "externals" "where to include the externals?">}})
        1.  [how to download externals from Pd vanilla?]({{< mdlink "externals" "how to download externals from Pd vanilla?">}})
    1.  [loading externals]({{< mdlink "externals" "loading externals">}})
        1.  [using the [declare] object]({{< mdlink "externals" "using the [declare] object">}})
            1.  [[declare -path]]({{< mdlink "externals" "[declare -path]">}})
            1.  [[declare -lib]]({{< mdlink "externals" "[declare -lib]">}})
        1.  [load via path and startup]({{< mdlink "externals" "load via path and startup">}})
            1.  [user added path]({{< mdlink "externals" "user added path">}})
            1.  [startup]({{< mdlink "externals" "startup">}})
        1.  [load using slash declarations]({{< mdlink "externals" "Slash declarations:">}})
    1.  [how external binaries are loaded]({{< mdlink "externals" "How external binaries are loaded">}})
        1.  [overriding objects (externals and native):]({{< mdlink "externals" "Overriding objects (externals and native):">}})
        1.  [search order for loading objects]({{< mdlink "externals" "Search order for loading objects">}})
1.  [installing from source]({{< mdlink "installing from source" "">}})
    1.  [requirements]({{< mdlink "installing from source" "requirements">}})
    1.  [autotools build (recommended)]({{< mdlink "installing from source" "autotools build (recommended)">}})
    1.  [Linux & BSD]({{< mdlink "installing from source" "Linux & BSD">}})
        1.  [BSD]({{< mdlink "more-bsd" "">}})
    1.  [macOS]({{< mdlink "installing from source" "macOS">}})
        1.  [macOS resources]({{< mdlink "more-macos" "">}})
    1.  [Windows]({{< mdlink "installing from source" "Windows">}})
        1.  [Windows resources]({{< mdlink "more-windows" "Windows resources">}})
        1.  [Windows ASIO support]({{< mdlink "more-windows" "Windows ASIO Support">}})
    1.  [double precision]({{< mdlink "installing from source" "double precision">}})
    1.  [other flags]({{< mdlink "installing from source" "other flags">}})
    1.  [cross-compilation for Windows on Linux]({{< mdlink "installing from source" "cross-compilation for Windows on Linux">}})
    1.  [makefile build]({{< mdlink "installing from source" "makefile build">}})
    1. [reporting bugs]({{< mdlink "installing from source" "reporting bugs">}})
1.  [current status]({{< mdlink "current status" "">}})
    1.  [release notes]({{< mdlink "current status" "release notes">}})
    1.  [known bugs]({{< mdlink "current status" "known bugs">}})
    1.  [differences from Max/MSP]({{< mdlink "current status" "differences from Max/MSP">}})
